-- VHDL behavioral specification of my cat

library ieee;
use ieee.std_logic_1164.all;

entity gadget is
  port (  clk:                          in std_logic;
          bath:                         in std_logic;
          eat, sleep, run_amok, whine:  out std_logic );
end gadget;

architecture behavioral of gadget is
  signal behavior: std_logic_vector(3 downto 0);
begin
  eat <= behavior(0);
  sleep <= behavior(1);
  run_amok <= behavior(2);
  whine <= behavior(3);
  
  process
  begin
    wait until (clk'event and clk = '1');
    if bath = '0' then
      if behavior(0) = '1' then
        behavior <= "0010";
      elsif behavior(1) = '1' then
        behavior <= "0100";
      else
        behavior <= "0001";
      end if;
    else
      behavior <= "1000";
    end if;
  end process;
end behavioral;
